//+------------------------------------------------------------------+
//|                                                 euroblaster-exp.mq4 |
//|                Copyright  2006, Nick Bilak, beluck[AT]gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Nick Bilak"
#property link      "http://www.mql4.info/"
#include <stdlib.mqh>

extern string EAName="euroblaster";
extern int MagicNumber =197893;

extern string PARAMETERS_FILTER = "PARAMETERS FILTER";
extern bool UseHourTrade = True;
extern int FromHourTrade = 8;
extern int ToHourTrade = 18;

extern double EquityGainPercent = 10; //Global percentage of equity exit
extern double ProfitExit = 2; //% profit exit
extern double Open_Loss_To_CloseTrades=-1000;

extern int        Mode=0; //0 - auto, 1 - manual
extern double     DeltaPrice=50;
extern int        ATRperiod=5;
extern double     ATRratio=0.824;
extern int        InitialStop =  0; 

extern int ATRStopPeriod = 20;
extern double ATRStopRatio = 3;
extern double ATRBreakevenStopRatio = 3;
extern int ATREnrtyPeriod = 20;
extern double ATREntryRatio = 5;

extern string i0="_indicators params_";
extern string i1="__volatility__";
extern int rtP=7;
extern int Voltrp=9;
extern int Voltype=4;
extern double  VolatilityHL=50;

extern string i2="__rsi2ma__";
extern int MA1pr=2;
extern int MA1type=14;

extern int MA2pr=6;
extern int MA2type=1;
extern int RSItpr=6;

extern double  MAofRSIUpHL=75;
extern double  MAofRSIDwnHL=25;

extern double MovingPeriod = 12;
extern double MovingShift = 0;

extern string i3="__deltastop__";
extern int     MODE=1; //0 - auto, 1 - manual
extern double  DELTAPrice=0.005;
extern int     ATRPeriod=14;
extern double  ATRRatio=2.824;

extern int    ConsecutiveTrades=3;

extern double Lots = 0.01;
extern int    LotRound=1; //digits after decimal point for lot size
extern double MinLot = 0.01;    //minimum lot size
extern double MaximumRisk = 2; //% risk. lot size will be calculated so that stoploss was equal to risk% of balance
extern bool   FixedLot = false; //trigger to use MM

extern int    slippage=2;   	//slippage for market order processing
extern int    shift=1;			//shift to current bar for entry 
extern int    OrderTriesNumber=2;

bool buysig,sellsig,closebuy,closesell,cancel,addbuy,addsell,exit,tickvalue,ma; 
int ord,tries,last,buys,sells,SL,TrStop,Trail_Stop,co;
double atrstop,atrentry,_1stentry,entryprice,_1stlots,avgpositionprofit,hbuy,lsell,curprof;
int nextTP;
bool sl;
int range = 5;
int multiplier;
int Slippage=5;

//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+

int init(){
   Trail_Stop = 0;

   //----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
//----------------------- SOURCE : PENGIE
   MagicNumber    = subGenerateMagicNumber(MagicNumber, Symbol(), Period());
   tickvalue = MarketInfo(Symbol(),MODE_TICKVALUE);
   
//----
   return(0);
  }

  

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()  {
   //---- check for history and trading
      if (UseHourTrade){
   if((Hour()>=FromHourTrade)&&(Hour()<=ToHourTrade))
      Comment("Trading Hours");
   else
     {
      Comment("Non-trading Hours");
      return(0);
     }
   }

   //---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;

   ord=CalculateCurrentOrders();
   //---- check for signals
   CheckForSignals();

   if (ord!=0) CheckForClose();

   CheckForOpen();
   getSpread();
   getOpenOrders();
 

   
   if (ScanTrades()<1) return(0);
   else
   if (ATRPeriod >0) TrailStop(); 
   
 return(0);
  {
double pcnt =( (AccountEquity()-AccountBalance()) / AccountBalance())*100;
Print("Account equity = ",AccountEquity());
Print("Account balance = ",AccountBalance());

 if(pcnt>EquityGainPercent)
 { 
int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type   = OrderType();

    bool result = false;
    
    switch(type)
    {
      //Close opened long positions
      case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
                          break;
      
      //Close opened short positions
      case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
                          break;

      //Close pending orders
      case OP_BUYLIMIT  :
      case OP_BUYSTOP   :
      case OP_SELLLIMIT :
      case OP_SELLSTOP  : result = OrderDelete( OrderTicket() );
    }
    
    if(result == false)
    {
      Alert("Order " , OrderTicket() , " failed to close. Error:" , GetLastError() );
      Sleep(3000);
    }  
  }
  
 
     Print("ALL ORDERS CLOSE-->Locked in on Profits");
 		 if (AccountProfit()<= Open_Loss_To_CloseTrades)
   {
    for(i=OrdersTotal()-1;i>=0;i--)
       {
              
       switch(type)
          {
          //Close opened long positions
          case OP_BUY  : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,Pink);
                         break;
               
          //Close opened short positions
          case OP_SELL : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,Pink);
                          
          }
          
       if(result == false)
          {
            Sleep(3000);
          }  
       }
      Print ("Account Cutoff Limit Reached. All Open Trades Have Been Closed");
      return(0);
   }  
   
   Comment("Balance: ",AccountBalance(),", Account Equity: ",AccountEquity(),", Account Profit: ",AccountProfit(),
           "\nMy Account Cutoff Limit: ",Open_Loss_To_CloseTrades);
   
  return(0);


  }
//+------------------------------------------------------------------+
 

   
}


}
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders()  {
   buys=0; sells=0; avgpositionprofit=0; hbuy=0; lsell=99999; curprof=0;
   string symbol=Symbol();
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) {
         curprof += OrderProfit()+OrderSwap();
         if(OrderType()==OP_BUY || OrderType()==OP_BUYSTOP)  buys++;
         if(OrderType()==OP_SELL || OrderType()==OP_SELLSTOP) sells++;
         if (OrderType()==OP_BUY) { avgpositionprofit+=OrderClosePrice()-OrderOpenPrice(); hbuy=MathMax(hbuy,OrderOpenPrice()); }
         if (OrderType()==OP_SELL) { avgpositionprofit+=-OrderClosePrice()+OrderOpenPrice(); lsell=MathMin(lsell,OrderOpenPrice()); }
      }
   }
   if (buys+sells!=0) avgpositionprofit=avgpositionprofit/(buys+sells);
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
}

double LotsRisk(int StopLoss)  { 
   //MM lot size calculation
   int sl=StopLoss;
   if (sl==0) sl=100;
   double lot=Lots;
//---- select lot size
   if (!FixedLot)
      lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk*0.001/sl,LotRound);
   else
      lot=Lots;
//---- return lot size
   if(lot<MinLot) lot=MinLot;
   return(lot);
}

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals() {

      addsell=false;
      addbuy=false;
      buysig=false;
      sellsig=false;
      closebuy=false;
      closesell=false;
      exit=false;


   	double VolCH=iCustom(NULL,0,"volatility",rtP,Voltrp,Voltype,0,shift);
   	double RSIndex1=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,0,shift);
   	double MAofRSI11=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,1,shift);
   	double MAofRSI21=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,2,shift);
   	double RSIndex2=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,0,shift+1);
   	double MAofRSI12=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,1,shift+1);
   	double MAofRSI22=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,2,shift+1);
   	double TrStop=iCustom(NULL,0,"delta-stop",MODE,DELTAPrice,ATRPeriod,ATRRatio,0,shift);
   	double ma=iMA(NULL,0,MovingPeriod,MovingShift,MODE_SMA,PRICE_CLOSE,0);
   	atrstop=iATR(NULL,0,ATRStopPeriod,shift);
   	atrentry=iATR(NULL,0,ATREnrtyPeriod,shift);

      if (ord==0) { _1stentry=-1; _1stlots=0; }
      int numentries;
      if (ord>0) {
         if (atrentry*ATREntryRatio!=0.0) numentries = MathFloor((Ask-_1stentry)/(atrentry*ATREntryRatio));
         if (numentries>ord) addbuy=true;
      }
      if (ord<0) {
         if (atrentry*ATREntryRatio!=0.0) numentries = MathFloor((_1stentry-Bid)/(atrentry*ATREntryRatio));
         if (numentries>(-ord)) addsell=true;
      }
      SL=atrstop*ATRStopRatio/Point/100.0;
      
      double VolHL=VolatilityHL;

      double HL1=MAofRSIUpHL;
      double HL2=MAofRSIDwnHL;
      double HLM=50;


      //bool Long = cross(MAofRSI,MAofRSI2) and VolCH>VolHL and RSIndex<HLM and RSIndex>HL2 and TrStop<C;
      bool Long = MAofRSI11>MAofRSI21 && MAofRSI12<MAofRSI22 && VolCH>VolHL && RSIndex1<HLM && RSIndex1>HL2 && TrStop<Close[shift] && Open [0]>=ma;
      //bool Short = cross(MAofRSI2,MAofRSI) and VolCH>VolHL and RSIndex<HL1 and RSIndex>HLM and TrStop>C;
      bool Short = MAofRSI11<MAofRSI21 && MAofRSI12>MAofRSI22 && VolCH>VolHL && RSIndex1<HL1 && RSIndex1>HLM && TrStop>Close[shift] && Open [0]<=ma;
      //bool Long2 = cross(MAofRSI,HLM) and cross(MAofRSI2,HLM) and VolCH>VolHL;
      bool Long2 = MAofRSI11>HLM && MAofRSI12<HLM && MAofRSI21>HLM && MAofRSI22<HLM && VolCH>VolHL && Open [0]>=ma;
      //bool Short2 = cross(HLM,MAofRSI) and cross(HLM,MAofRSI2) and VolCH>VolHL;
      bool Short2 = MAofRSI11<HLM && MAofRSI12>HLM && MAofRSI21<HLM && MAofRSI22>HLM && VolCH>VolHL && Open [0]<=ma;
      //bool Long3 = RSIndex-ref(RSIndex,-1)>20;
      bool Long3 = RSIndex1-RSIndex2>20 && Open [0]>=ma;
      //bool Short3 = ref(RSIndex,-1)-RSIndex>20;
      bool Short3 = RSIndex2-RSIndex1>20 && Open [0]<=ma;

      buysig = Long  || Long2 || Long3;
      sellsig = Short || Short2 || Short3;

      closebuy=sellsig;
      closesell=buysig;
      
            if (curprof>=AccountEquity()*ProfitExit/100.0) {
         exit=true;

            

      

      }
}
void CheckForOpen() {

   int    res;
   double entry,stop,profit;
   
   if (exit) return;
   
//---- buy conditions
   if (addbuy)  {
		res=OpenAtMarket(OP_BUY,_1stlots);
		if (res<=0) Print("Error opening BUY order : ",ErrorDescription(GetLastError()));
   }
//---- sell conditions
   if (addsell)  {
		res=OpenAtMarket(OP_SELL,_1stlots);
		if (res<=0) Print("Error opening SELL order : ",ErrorDescription(GetLastError()));
   }

   if (last==Time[0]) return;

   ord=CalculateCurrentOrders();

   if (ord!=0) CheckForClose();

   ord=CalculateCurrentOrders();

//---- buy conditions
   if (buys<ConsecutiveTrades && buysig)  {
		res=OpenAtMarket(OP_BUY,LotsRisk(SL));
		if (res<0) Print("Error opening BUY order : ",ErrorDescription(GetLastError()));
		else { last=Time[0]; _1stlots=LotsRisk(SL); _1stentry=entryprice;  }
   }
//---- sell conditions
   if (-sells<ConsecutiveTrades && sellsig)  {
		res=OpenAtMarket(OP_SELL,LotsRisk(SL));
		if (res<=0) Print("Error opening SELL order : ",ErrorDescription(GetLastError()));
		else { last=Time[0]; _1stlots=LotsRisk(SL); _1stentry=entryprice;  }
   }
}
  
int OpenAtMarket(int mode,double lot) {
   int    res,tr,col;
   double openprice,sl,tp;
   tries=0;
   while (res<=0 && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      if (mode==OP_SELL) {
         openprice=Bid; 
         col=Red;
      } else {
         //openprice=nd(Ask);
         openprice=Ask;
         col=Blue;
      }
      entryprice=openprice;
      res=OrderSend(Symbol(),mode,lot,openprice,slippage,sl,tp,EAName+MagicNumber,MagicNumber,0,col);
      tries++;
   }
   return(res);
}
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()  {
	int total;
	total=OrdersTotal();
   for(int i=total;i>=0;i--) {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))  continue;
      if(OrderMagicNumber()!=MagicNumber || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY && (exit)) CloseAtMarket(OrderTicket(),OrderLots());
      if(OrderType()==OP_SELL && (exit)) CloseAtMarket(OrderTicket(),OrderLots());
   }
   if (exit) last=Time[0];
}

bool CloseAtMarket(int ticket,double lot) {
   bool bres=false; int tr;
   tries=0;
   while (!bres && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      bres=OrderClose(ticket,lot,OrderClosePrice(),slippage,White);
      if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
      tries++;
   }
}


// ---- Stepped Stops
void TrailStop()
{
   double minstop = MarketInfo(Symbol(),MODE_STOPLEVEL);
   double ask = MarketInfo(Symbol(),MODE_ASK);
   double bid = MarketInfo(Symbol(),MODE_BID);
   double Delta=iCustom(NULL,0,"delta-stop",MODE,DELTAPrice,ATRPeriod,ATRRatio);
   
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol()) 
      {
         if (mode==OP_BUY) 
         {
			double BuyStop = Delta;
			if(OrderStopLoss() == 0 && InitialStop>0 ) BuyStop = Bid-InitialStop*Point;  
			if((bid - BuyStop) < minstop*Point) BuyStop = bid - minstop*Point;   
			Print("delta-stop=",Delta," BuyStop=",BuyStop);
			   if ((OrderOpenPrice() <= BuyStop && BuyStop > OrderStopLoss()) || OrderStopLoss()==0) 
			   {
			   bool result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                             NormalizeDouble(BuyStop, Digits),
			                             OrderTakeProfit(),0,LightGreen);
			      if( !result )
               {
               Print("BUY: OrderModify failed with error #",GetLastError());
               }
			      return(0);
                          
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
         double SellStop = Delta;   
         if (OrderStopLoss()==0 && InitialStop > 0) SellStop = ask+InitialStop*Point;
         if((SellStop-ask) < minstop*Point)  SellStop = ask + minstop*Point;  
         Print("delta-stop=",Delta," SellStop=",SellStop);   
            if( (OrderOpenPrice() >= SellStop && OrderStopLoss() > SellStop) || OrderStopLoss()==0) 
            {
            OrderModify(OrderTicket(), OrderOpenPrice(),
                        NormalizeDouble(SellStop, Digits),
			               OrderTakeProfit(),0,DarkOrange);
               if( !result )
               {
               Print("SELL: OrderModify failed with error #",GetLastError());
               }
               return(0);
               
   			}	    
         }
      }
   }     
}


// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELL) 
   numords++;
   }
   return(numords);
}
 
//========== FUNCTION getPipValue
double getPipValue(double ord,int dir)
{
   double val;
   RefreshRates();
   if(dir == 1) val=(NormalizeDouble(ord,Digits) - 
NormalizeDouble(Ask,Digits));
   else val=(NormalizeDouble(Bid,Digits) - NormalizeDouble(ord,Digits));
   val = val/Point*co;
   return(val);
}
//== end function

int getSpread()
{
   int spread=MarketInfo(Symbol(),MODE_SPREAD);
   return(spread);
}



//========== FUNCTION getOpenOrders
void getOpenOrders()
{
   int nsl, nsd;
   string mngMagic, trailon;
   int totalorders = OrdersTotal();
   for(int j=0; j<totalorders;j++)
     {
         OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
         if((OrderType() == OP_BUY || OrderType() == OP_SELL) && 
OrderSymbol() == Symbol()&&(MagicNumber==0 || MagicNumber == 
OrderMagicNumber()))
         {

            double val=getPipValue(OrderOpenPrice(),OrderType());
            //int val = OrderProfit()/(OrderLots()*10);
            
           

         }

         if(MagicNumber == 0)
         mngMagic = "All "+Symbol()+" trades.";
         else
         mngMagic = "Trades with magic number = "+MagicNumber;




         //RefreshRates();
         Comment("Balance: ",AccountBalance(),", Account Equity: ",AccountEquity(),", Account Profit: ",AccountProfit(),"Order Open: ",OrderOpenPrice(),
         "\nPip Count: ", val,
         "\nMy Account Cutoff Limit: ",Open_Loss_To_CloseTrades,
         "\nManaging: ", mngMagic);
  }
}
//+------------------------------------------------------------------+
//+--------------------------END OF PROGRAM--------------------------+


//----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
//----------------------- SOURCE   : PENGIE

int subGenerateMagicNumber(int Magic_Number, string symbol, int timeFrame)
{
   int isymbol = 0;
   if (symbol == "EURUSD")       isymbol = 1;
   else if (symbol == "GBPUSD")  isymbol = 2;
   else if (symbol == "USDJPY")  isymbol = 3;
   else if (symbol == "USDCHF")  isymbol = 4;
   else if (symbol == "AUDUSD")  isymbol = 5;
   else if (symbol == "USDCAD")  isymbol = 6;
   else if (symbol == "EURGBP")  isymbol = 7;
   else if (symbol == "EURJPY")  isymbol = 8;
   else if (symbol == "EURCHF")  isymbol = 9;
   else if (symbol == "EURAUD")  isymbol = 10;
   else if (symbol == "EURCAD")  isymbol = 11;
   else if (symbol == "GBPUSD")  isymbol = 12;
   else if (symbol == "GBPJPY")  isymbol = 13;
   else if (symbol == "GBPCHF")  isymbol = 14;
   else if (symbol == "GBPAUD")  isymbol = 15;
   else if (symbol == "GBPCAD")  isymbol = 16;
   else                          isymbol = 17;
   if(isymbol<10) Magic_Number = MagicNumber * 10;
   return (StrToInteger(StringConcatenate(MagicNumber, isymbol, timeFrame)));
   
}

